org.optaplanner.core.impl.domain.variable.inverserelation

## Class CollectionInverseVariableListener

- java.lang.Object
- - org.optaplanner.core.impl.domain.variable.inverserelation.CollectionInverseVariableListener

- All Implemented Interfaces:
    Closeable, AutoCloseable, VariableListener<Object>, CollectionInverseVariableSupply, Supply

      public class CollectionInverseVariableListener
      extends Object
      implements VariableListener<Object>, CollectionInverseVariableSupply

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected InverseRelationShadowVariableDescriptor` | `shadowVariableDescriptor`
    `protected VariableDescriptor` | `sourceVariableDescriptor`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CollectionInverseVariableListener(InverseRelationShadowVariableDescriptor shadowVariableDescriptor, VariableDescriptor sourceVariableDescriptor)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterEntityAdded(ScoreDirector scoreDirector, Object entity)`
    `void` | `afterEntityRemoved(ScoreDirector scoreDirector, Object entity)`
    `void` | `afterVariableChanged(ScoreDirector scoreDirector, Object entity)`
    `void` | `beforeEntityAdded(ScoreDirector scoreDirector, Object entity)`
    `void` | `beforeEntityRemoved(ScoreDirector scoreDirector, Object entity)`
    `void` | `beforeVariableChanged(ScoreDirector scoreDirector, Object entity)`
    `Collection<?>` | `getInverseCollection(Object planningValue)` If entity1.varA = x then an inverse of x is entity1.
    `protected void` | `insert(ScoreDirector scoreDirector, Object entity)`
    `protected void` | `retract(ScoreDirector scoreDirector, Object entity)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.domain.variable.listener.VariableListener

      `requiresUniqueEntityEvents`

    - ### Methods inherited from interface org.optaplanner.core.api.domain.variable.VariableListener

      `close, resetWorkingSolution`

- - ### Field Detail

    - #### shadowVariableDescriptor

          protected final InverseRelationShadowVariableDescriptor shadowVariableDescriptor

    - #### sourceVariableDescriptor

          protected final VariableDescriptor sourceVariableDescriptor

  - ### Constructor Detail

    - #### CollectionInverseVariableListener

          public CollectionInverseVariableListener(InverseRelationShadowVariableDescriptor shadowVariableDescriptor,
                                                   VariableDescriptor sourceVariableDescriptor)

  - ### Method Detail

    - #### beforeEntityAdded

          public void beforeEntityAdded(ScoreDirector scoreDirector,
                                        Object entity)

      Specified by:
        `beforeEntityAdded` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### afterEntityAdded

          public void afterEntityAdded(ScoreDirector scoreDirector,
                                       Object entity)

      Specified by:
        `afterEntityAdded` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### beforeVariableChanged

          public void beforeVariableChanged(ScoreDirector scoreDirector,
                                            Object entity)

      Specified by:
        `beforeVariableChanged` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### afterVariableChanged

          public void afterVariableChanged(ScoreDirector scoreDirector,
                                           Object entity)

      Specified by:
        `afterVariableChanged` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### beforeEntityRemoved

          public void beforeEntityRemoved(ScoreDirector scoreDirector,
                                          Object entity)

      Specified by:
        `beforeEntityRemoved` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### afterEntityRemoved

          public void afterEntityRemoved(ScoreDirector scoreDirector,
                                         Object entity)

      Specified by:
        `afterEntityRemoved` in interface `VariableListener<Object>`
      Parameters:
        `scoreDirector` - never null
        `entity` - never null

    - #### insert

          protected void insert(ScoreDirector scoreDirector,
                                Object entity)

    - #### retract

          protected void retract(ScoreDirector scoreDirector,
                                 Object entity)

    - #### getInverseCollection

          public Collection<?> getInverseCollection(Object planningValue)

      Description copied from interface: `CollectionInverseVariableSupply`
      If entity1.varA = x then an inverse of x is entity1.
      Specified by:
        `getInverseCollection` in interface `CollectionInverseVariableSupply`
      Parameters:
        `planningValue` - never null
      Returns:
        never null, a `Collection` of entities for which the planning variable is the planningValue.

Copyright © 2006–2021 JBoss by Red Hat. All rights reserved.